using System;
using System.Data.SqlClient;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace SvetoforVKBot.Models.Commands.LK.Reports
{
    public class SelectReportCcalCommand : Command
    {
        public override string Name => "{\"button\":\"selectReportCcal-";

        public override void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
        }

        public override void ExecutePL(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            var chatId = update.@object.message.from_id;
            MessagesSendParams @params = new MessagesSendParams();
            Regex regex = new Regex("[^0-9]");
            string msg = "";
            var keyboardBuilder = new KeyboardBuilder().Clear();

            try
            {
                string[] payload = update.@object.message.payload.Split('-');
                int result = Convert.ToInt32(regex.Replace(payload[1], ""));

                var user = db.Users.Single(usr => usr.chatId == chatId);
                user.tag = "Отчет - Комменнт";
                db.SaveChanges();

                var report = db.Reports.Where(r => r.chatId == chatId).Max();
                report.result = result;
                db.SaveChanges();

                @params.Message = "Оставьте несколько слов о прошедшем дне😌";

                keyboardBuilder
                    .AddButton("Пропустить", "Пропустить", KeyboardButtonColor.Primary)
                    .AddLine()
                    .AddButton("Назад", "startPL", KeyboardButtonColor.Default);

                @params.Keyboard = keyboardBuilder.Build();
                @params.UserId = chatId;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);

            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в SelectReportCcalCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }
    }
}